'=====================================================================
'Copyright(c), Meilhaus Electronic GmbH
'              http://www.meilhaus.de
'              support@meilhaus.de
'
'Source File : meIDS.vb
'
'              THIS FILE IS DEPRECATED.
'
'Important   : For new projects it is recommended to use the meIDS.vb
'              in the folder "MS Visual Basic 2010" of the SDK
'Description : Constants, types and function prototypes of the ME-iDS API
'              for accessing the API in Visual Basic .NET using CallingConvention.StdCall
'Note        : import library for ME-iDS API, only 32bit available: meIDSmainVB.dll
'=====================================================================
Option Strict Off
Option Explicit On

Imports System.Runtime.InteropServices

Module Module1
    '-------------------------------------------------------------------------------
    '
    ' me-iDS Constants
    '
    '-------------------------------------------------------------------------------

    '================================================================
    '  General
    '================================================================

    Public Const ME_VALUE_NOT_USED As Integer = &H0S

    Public Const ME_VALUE_DEFAULT As Integer = &H0S

    Public Const ME_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines common to access functions
    '===============================================================

    Public Const ME_LOCK_RELEASE As Integer = &H10001
    Public Const ME_LOCK_SET As Integer = &H10002
    Public Const ME_LOCK_CHECK As Integer = &H10003

    '===============================================================
    '  Defines meOpen function
    '===============================================================

    Public Const ME_OPEN_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines meClose function
    '===============================================================

    Public Const ME_CLOSE_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines meLockDriver function
    '===============================================================

    Public Const ME_LOCK_DRIVER_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines meLockDevice function
    '===============================================================

    Public Const ME_LOCK_DEVICE_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines meLockSubdevice function
    '===============================================================

    Public Const ME_LOCK_SUBDEVICE_NO_FLAGS As Integer = &H0S


    '===============================================================
    '  Defines common to error functions
    '===============================================================

    Public Const ME_ERROR_MSG_MAX_COUNT As Integer = 256

    '===============================================================
    '  Defines for meErrorSetDefaultProc function
    '===============================================================

    Public Const ME_SWITCH_DISABLE As Integer = &H20001
    Public Const ME_SWITCH_ENABLE As Integer = &H20002

    '===============================================================
    '  Defines common to io functions
    '===============================================================

    Public Const ME_REF_NONE As Integer = &H0
    Public Const ME_REF_DIO_FIFO_LOW As Integer = &H30001
    Public Const ME_REF_DIO_FIFO_HIGH As Integer = &H30002

    Public Const ME_REF_CTR_PREVIOUS As Integer = &H40001
    Public Const ME_REF_CTR_INTERNAL_1MHZ As Integer = &H40002
    Public Const ME_REF_CTR_INTERNAL_10MHZ As Integer = &H40003
    Public Const ME_REF_CTR_EXTERNAL As Integer = &H40004

    Public Const ME_REF_AI_GROUND As Integer = &H50001
    Public Const ME_REF_AI_DIFFERENTIAL As Integer = &H50002

    Public Const ME_REF_AO_GROUND As Integer = &H60001
    Public Const ME_REF_AO_DIFFERENTIAL As Integer = &H60002

    Public Const ME_TRIG_CHAN_DEFAULT As Integer = &H70001
    Public Const ME_TRIG_CHAN_SYNCHRONOUS As Integer = &H70002

    Public Const ME_TRIG_TYPE_NONE As Integer = ME_VALUE_NOT_USED
    Public Const ME_TRIG_TYPE_SW As Integer = &H80001
    Public Const ME_TRIG_TYPE_THRESHOLD As Integer = &H80002
    Public Const ME_TRIG_TYPE_WINDOW As Integer = &H80003
    Public Const ME_TRIG_TYPE_EDGE As Integer = &H80004
    Public Const ME_TRIG_TYPE_SLOPE As Integer = &H80005
    Public Const ME_TRIG_TYPE_EXT_DIGITAL As Integer = &H80006
    Public Const ME_TRIG_TYPE_EXT_ANALOG As Integer = &H80007
    Public Const ME_TRIG_TYPE_PATTERN As Integer = &H80008
    Public Const ME_TRIG_TYPE_TIMER As Integer = &H80009
    Public Const ME_TRIG_TYPE_COUNT As Integer = &H8000A
    Public Const ME_TRIG_TYPE_FOLLOW As Integer = &H8000B

    Public Const ME_TRIG_EDGE_NONE As Integer = ME_VALUE_NOT_USED
    Public Const ME_TRIG_EDGE_ABOVE As Integer = &H90001
    Public Const ME_TRIG_EDGE_BELOW As Integer = &H90002
    Public Const ME_TRIG_EDGE_ENTRY As Integer = &H90003
    Public Const ME_TRIG_EDGE_EXIT As Integer = &H90004
    Public Const ME_TRIG_EDGE_RISING As Integer = &H90005
    Public Const ME_TRIG_EDGE_FALLING As Integer = &H90006
    Public Const ME_TRIG_EDGE_ANY As Integer = &H90007

    Public Const ME_TIMER_ACQ_START As Integer = &HA0001
    Public Const ME_TIMER_SCAN_START As Integer = &HA0002
    Public Const ME_TIMER_CONV_START As Integer = &HA0003
    Public Const ME_TIMER_FIO_TOTAL As Integer = &HA0004
    Public Const ME_TIMER_FIO_FIRST_PHASE As Integer = &HA0005

    '===============================================================
    '  Defines for meIOFrequencyToTicks function
    '===============================================================

    Public Const ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_STREAM_FREQUENCY_TO_TICKS_NO_FLAGS = ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS
    Public Const ME_IO_FREQUENCY_TO_TICKS_MEPHISTO_SCOPE_OSCILLOSCOPE As Integer = &H1S

    '===============================================================
    '  Defines for meIOIrqStart function
    '===============================================================

    Public Const ME_IRQ_SOURCE_DIO_PATTERN As Integer = &HB0001
    Public Const ME_IRQ_SOURCE_DIO_MASK As Integer = &HB0002
    Public Const ME_IRQ_SOURCE_DIO_LINE As Integer = &HB0003
    Public Const ME_IRQ_SOURCE_DIO_OVER_TEMP As Integer = &HB0004
    Public Const ME_IRQ_SOURCE_DIO_NORMAL_TEMP As Integer = &HB0005
    Public Const ME_IRQ_SOURCE_DIO_CHANGE_TEMP As Integer = &HB0006

    Public Const ME_IRQ_EDGE_NOT_USED As Integer = ME_VALUE_NOT_USED
    Public Const ME_IRQ_EDGE_RISING As Integer = &HC0001
    Public Const ME_IRQ_EDGE_FALLING As Integer = &HC0002
    Public Const ME_IRQ_EDGE_ANY As Integer = &HC0003

    Public Const ME_IO_IRQ_START_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_IRQ_START_DIO_BIT As Integer = &H1S
    Public Const ME_IO_IRQ_START_DIO_BYTE As Integer = &H2S
    Public Const ME_IO_IRQ_START_DIO_WORD As Integer = &H4S
    Public Const ME_IO_IRQ_START_DIO_DWORD As Integer = &H8S
    Public Const ME_IO_IRQ_START_PATTERN_FILTERING As Integer = &H10S
    Public Const ME_IO_IRQ_START_EXTENDED_STATUS As Integer = &H20S
    Public Const ME_IO_IRQ_START_USE_PROPERTIES As Integer = &H40000000

    '===============================================================
    '  Defines for meIOIrqWait function
    '===============================================================

    Public Const ME_IO_IRQ_WAIT_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_IRQ_WAIT_NORMAL_STATUS As Integer = &H1S
    Public Const ME_IO_IRQ_WAIT_EXTENDED_STATUS As Integer = &H2S

    '===============================================================
    '  Defines for meIOIrqStop function
    '===============================================================

    Public Const ME_IO_IRQ_STOP_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOIrqSetCallback function
    '===============================================================

    Public Const ME_IO_IRQ_SET_CALLBACK_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOResetDevice function
    '===============================================================

    Public Const ME_IO_RESET_DEVICE_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOResetSubdevice function
    '===============================================================

    Public Const ME_IO_RESET_SUBDEVICE_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOSingleConfig function
    '===============================================================

    Public Const ME_SINGLE_CONFIG_DIO_INPUT As Integer = &HD0001
    Public Const ME_SINGLE_CONFIG_DIO_OUTPUT As Integer = &HD0002
    Public Const ME_SINGLE_CONFIG_DIO_HIGH_IMPEDANCE As Integer = &HD0003
    Public Const ME_SINGLE_CONFIG_DIO_SINK As Integer = &HD0004
    Public Const ME_SINGLE_CONFIG_DIO_SOURCE As Integer = &HD0005
    Public Const ME_SINGLE_CONFIG_DIO_MUX32M As Integer = &HD0006
    Public Const ME_SINGLE_CONFIG_DIO_DEMUX32 As Integer = &HD0007
    Public Const ME_SINGLE_CONFIG_DIO_BIT_PATTERN As Integer = &HD0008

    Public Const ME_SINGLE_CONFIG_CTR_8254_MODE_0 As Integer = &HE0001
    Public Const ME_SINGLE_CONFIG_CTR_8254_MODE_1 As Integer = &HE0002
    Public Const ME_SINGLE_CONFIG_CTR_8254_MODE_2 As Integer = &HE0003
    Public Const ME_SINGLE_CONFIG_CTR_8254_MODE_3 As Integer = &HE0004
    Public Const ME_SINGLE_CONFIG_CTR_8254_MODE_4 As Integer = &HE0005
    Public Const ME_SINGLE_CONFIG_CTR_8254_MODE_5 As Integer = &HE0006

    Public Const ME_IO_SINGLE_CONFIG_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_SINGLE_CONFIG_DIO_BIT As Integer = &H1S
    Public Const ME_IO_SINGLE_CONFIG_DIO_BYTE As Integer = &H2S
    Public Const ME_IO_SINGLE_CONFIG_DIO_WORD As Integer = &H4S
    Public Const ME_IO_SINGLE_CONFIG_DIO_DWORD As Integer = &H8S
    Public Const ME_IO_SINGLE_CONFIG_MULTISIG_LED_ON As Integer = &H10S
    Public Const ME_IO_SINGLE_CONFIG_MULTISIG_LED_OFF As Integer = &H20S
    Public Const ME_IO_SINGLE_CONFIG_AI_RMS As Integer = &H40S

    '===============================================================
    '  Defines for meIOSingle function
    '===============================================================

    Public Const ME_IO_SINGLE_NO_FLAGS As Integer = &H0S

    Public Const ME_DIR_INPUT As Integer = &HF0001
    Public Const ME_DIR_OUTPUT As Integer = &HF0002
    Public Const ME_DIR_SET_OFFSET As Integer = &HF0003

    Public Const ME_IO_SINGLE_TYPE_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_SINGLE_TYPE_DIO_BIT As Integer = &H1S
    Public Const ME_IO_SINGLE_TYPE_DIO_BYTE As Integer = &H2S
    Public Const ME_IO_SINGLE_TYPE_DIO_WORD As Integer = &H4S
    Public Const ME_IO_SINGLE_TYPE_DIO_DWORD As Integer = &H8S
    Public Const ME_IO_SINGLE_TYPE_TRIG_SYNCHRONOUS As Integer = &H10S
    Public Const ME_IO_SINGLE_TYPE_WRITE_NONBLOCKING As Integer = &H20S

    Public Const ME_IO_SINGLE_TYPE_FIO_DIVIDER As Integer = &H40
    Public Const ME_IO_SINGLE_TYPE_FO_START_LOW As Integer = &H80
    Public Const ME_IO_SINGLE_TYPE_FO_START_SOFT As Integer = &H100
    Public Const ME_IO_SINGLE_TYPE_FI_LAST_VALUE As Integer = &H200
    Public Const ME_IO_SINGLE_TYPE_FO_UPDATE_ONLY As Integer = &H200
    Public Const ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL As Integer = &H400
    Public Const ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE As Integer = &H800

    '==================================================================
    '  Defines for meIOSingleTimeToTicks function
    '==================================================================

    Public Const ME_IO_SINGLE_TIME_TO_TICKS_NO_FLAGS As Integer = &H0S

    '==================================================================
    '  Defines for meIOSingleTicksToTime function
    '==================================================================

    Public Const ME_IO_SINGLE_TICKS_TO_TIME_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOSetChannelOffset function
    '===============================================================

    Public Const ME_IO_SET_CHANNEL_OFFSET_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOStreamConfig function
    '===============================================================

    Public Const ME_IO_STREAM_CONFIG_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_STREAM_CONFIG_BIT_PATTERN As Integer = &H1S
    Public Const ME_IO_STREAM_CONFIG_WRAPAROUND As Integer = &H2S
    Public Const ME_IO_STREAM_CONFIG_SAMPLE_AND_HOLD As Integer = &H4S

    Public Const ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS As Integer = &H0S

    Public Const ME_IO_STREAM_TRIGGER_TYPE_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOStreamRead function
    '===============================================================

    Public Const ME_READ_MODE_BLOCKING As Integer = &H100001
    Public Const ME_READ_MODE_NONBLOCKING As Integer = &H100002

    Public Const ME_IO_STREAM_READ_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_STREAM_READ_FRAMES As Integer = &H1S

    '===============================================================
    '  Defines for meIOStreamWrite function
    '===============================================================

    Public Const ME_WRITE_MODE_BLOCKING As Integer = &H110001
    Public Const ME_WRITE_MODE_NONBLOCKING As Integer = &H110002
    Public Const ME_WRITE_MODE_PRELOAD As Integer = &H110003

    Public Const ME_IO_STREAM_WRITE_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOStreamStart function
    '===============================================================

    Public Const ME_IO_STREAM_START_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_STREAM_START_NONBLOCKING As Integer = &H20S

    Public Const ME_START_MODE_BLOCKING As Integer = &H120001
    Public Const ME_START_MODE_NONBLOCKING As Integer = &H120002

    Public Const ME_IO_STREAM_START_TYPE_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_STREAM_START_TYPE_TRIG_SYNCHRONOUS As Integer = &H1S

    '===============================================================
    '  Defines for meIOStreamStop function
    '===============================================================

    Public Const ME_IO_STREAM_STOP_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_STREAM_STOP_NONBLOCKING As Integer = &H20S

    Public Const ME_STOP_MODE_IMMEDIATE As Integer = &H130001
    Public Const ME_STOP_MODE_LAST_VALUE As Integer = &H130002

    Public Const ME_IO_STREAM_STOP_TYPE_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOStreamStatus function
    '===============================================================

    Public Const ME_WAIT_NONE As Integer = &H140001
    Public Const ME_WAIT_IDLE As Integer = &H140002
    Public Const ME_WAIT_BUSY As Integer = &H140003

    Public Const ME_STATUS_INVALID As Integer = &H0S
    Public Const ME_STATUS_IDLE As Integer = &H150001
    Public Const ME_STATUS_BUSY As Integer = &H150002
    Public Const ME_STATUS_ERROR As Integer = &H150003

    Public Const ME_IO_STREAM_STATUS_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOStreamSetCallbacks function
    '===============================================================

    Public Const ME_IO_STREAM_SET_CALLBACKS_NO_FLAGS As Integer = &H0S

    '===============================================================
    '  Defines for meIOStreamTimeToTicks function
    '===============================================================

    Public Const ME_IO_TIME_TO_TICKS_NO_FLAGS As Integer = &H0S
    Public Const ME_IO_STREAM_TIME_TO_TICKS_NO_FLAGS = ME_IO_TIME_TO_TICKS_NO_FLAGS
    Public Const ME_IO_TIME_TO_TICKS_MEPHISTO_SCOPE_OSCILLOSCOPE As Integer = &H1S

    '===============================================================
    '  Defines for module types
    '===============================================================

    Public Const ME_MODULE_TYPE_MULTISIG_NONE As Integer = &H0S
    Public Const ME_MODULE_TYPE_MULTISIG_DIFF16_10V As Integer = &H160001
    Public Const ME_MODULE_TYPE_MULTISIG_DIFF16_20V As Integer = &H160002
    Public Const ME_MODULE_TYPE_MULTISIG_DIFF16_50V As Integer = &H160003
    Public Const ME_MODULE_TYPE_MULTISIG_CURRENT16_0_20MA As Integer = &H160004
    Public Const ME_MODULE_TYPE_MULTISIG_RTD8_PT100 As Integer = &H160005
    Public Const ME_MODULE_TYPE_MULTISIG_RTD8_PT500 As Integer = &H160006
    Public Const ME_MODULE_TYPE_MULTISIG_RTD8_PT1000 As Integer = &H160007
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TYPE_B As Integer = &H160008
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TYPE_E As Integer = &H160009
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TYPE_J As Integer = &H16000A
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TYPE_K As Integer = &H16000B
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TYPE_N As Integer = &H16000C
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TYPE_R As Integer = &H16000D
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TYPE_S As Integer = &H16000E
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TYPE_T As Integer = &H16000F
    Public Const ME_MODULE_TYPE_MULTISIG_TE8_TEMP_SENSOR As Integer = &H160010

    '===============================================================
    '  Defines for meQuerySubdeviceCaps function
    '===============================================================

    Public Const ME_CAPS_DIO_DIR_BIT As Integer = &H1S
    Public Const ME_CAPS_DIO_DIR_BYTE As Integer = &H2S
    Public Const ME_CAPS_DIO_DIR_WORD As Integer = &H4S
    Public Const ME_CAPS_DIO_DIR_DWORD As Integer = &H8S
    Public Const ME_CAPS_DIO_SINK_SOURCE As Integer = &H10S
    Public Const ME_CAPS_DIO_BIT_PATTERN_IRQ As Integer = &H20S
    Public Const ME_CAPS_DIO_BIT_MASK_IRQ_EDGE_RISING As Integer = &H40S
    Public Const ME_CAPS_DIO_BIT_MASK_IRQ_EDGE_FALLING As Integer = &H80S
    Public Const ME_CAPS_DIO_BIT_MASK_IRQ_EDGE_ANY As Integer = &H100S
    Public Const ME_CAPS_DIO_OVER_TEMP_IRQ As Integer = &H200S
    Public Const ME_CAPS_DIO_NORMAL_TEMP_IRQ As Integer = &H400S

    Public Const ME_CAPS_CTR_CLK_PREVIOUS As Integer = &H1S
    Public Const ME_CAPS_CTR_CLK_INTERNAL_1MHZ As Integer = &H2S
    Public Const ME_CAPS_CTR_CLK_INTERNAL_10MHZ As Integer = &H4S
    Public Const ME_CAPS_CTR_CLK_EXTERNAL As Integer = &H8S

    Public Const ME_CAPS_AI_TRIG_SIMULTANEOUS As Integer = &H1S
    Public Const ME_CAPS_AI_FIFO As Integer = &H2S
    Public Const ME_CAPS_AI_FIFO_THRESHOLD As Integer = &H4S
    Public Const ME_CAPS_AI_SAMPLE_HOLD As Integer = &H8S

    Public Const ME_CAPS_AO_TRIG_SIMULTANEOUS As Integer = &H1S
    Public Const ME_CAPS_AO_FIFO As Integer = &H2S
    Public Const ME_CAPS_AO_FIFO_THRESHOLD As Integer = &H4S

    Public Const ME_CAPS_FIO_SINK_SOURCE As Integer = &H1S

    Public Const ME_CAPS_EXT_IRQ_EDGE_RISING As Integer = &H1S
    Public Const ME_CAPS_EXT_IRQ_EDGE_FALLING As Integer = &H2S
    Public Const ME_CAPS_EXT_IRQ_EDGE_ANY As Integer = &H4S

    '===============================================================
    '  Defines for meQuerySubdeviceCapsArgs function
    '===============================================================

    Public Const ME_CAP_AI_FIFO_SIZE As Integer = &H1D0000
    Public Const ME_CAP_AI_BUFFER_SIZE As Integer = &H1D0001
    Public Const ME_CAP_AI_CHANNEL_LIST_SIZE As Integer = &H1D0002
    Public Const ME_CAP_AI_MAX_THRESHOLD_SIZE As Integer = &H1D0003

    Public Const ME_CAP_AO_FIFO_SIZE As Integer = &H1F0000
    Public Const ME_CAP_AO_BUFFER_SIZE As Integer = &H1F0001
    Public Const ME_CAP_AO_CHANNEL_LIST_SIZE As Integer = &H1F0002
    Public Const ME_CAP_AO_MAX_THRESHOLD_SIZE As Integer = &H1F0003

    Public Const ME_CAP_CTR_WIDTH As Integer = &H200000

    Public Const ME_CAP_FPGA_IN_BUFFER_SIZE As Integer = &H300001
    Public Const ME_CAP_FPGA_OUT_FIFO_SIZE As Integer = &H300002
    Public Const ME_CAP_FPGA_OUT_BUFFER_SIZE As Integer = &H300003

    '===============================================================
    '  Defines common to query functions
    '===============================================================

    Public Const ME_UNIT_INVALID As Integer = &H0S
    Public Const ME_UNIT_VOLT As Integer = &H170001
    Public Const ME_UNIT_AMPERE As Integer = &H170002
    Public Const ME_UNIT_ANY As Integer = &H170003
    Public Const ME_UNIT_HZ As Integer = &H170004

    Public Const ME_TYPE_INVALID As Integer = &H0S
    Public Const ME_TYPE_AO As Integer = &H180001
    Public Const ME_TYPE_AI As Integer = &H180002
    Public Const ME_TYPE_DIO As Integer = &H180003
    Public Const ME_TYPE_DO As Integer = &H180004
    Public Const ME_TYPE_DI As Integer = &H180005
    Public Const ME_TYPE_CTR As Integer = &H180006
    Public Const ME_TYPE_EXT_IRQ As Integer = &H180007
    Public Const ME_TYPE_FIO As Integer = &H180008
    Public Const ME_TYPE_FO As Integer = &H180009
    Public Const ME_TYPE_FI As Integer = &H18000A
    Public Const ME_TYPE_FPGA As Integer = &H18000B

    Public Const ME_SUBTYPE_INVALID As Integer = &H0S
    Public Const ME_SUBTYPE_SINGLE As Integer = &H190001
    Public Const ME_SUBTYPE_STREAMING As Integer = &H190002
    Public Const ME_SUBTYPE_CTR_8254 As Integer = &H190003
    Public Const ME_SUBTYPE_ANY As Integer = &H190004

    Public Const ME_DEVICE_DRIVER_NAME_MAX_COUNT As Integer = 64
    Public Const ME_DEVICE_NAME_MAX_COUNT As Integer = 64

    Public Const ME_DEVICE_DESCRIPTION_MAX_COUNT As Integer = 256

    Public Const ME_BUS_TYPE_INVALID As Integer = &H0S
    Public Const ME_BUS_TYPE_ANY As Integer = &H1A0000    'ME_BUS_TYPE_ANY only for checking bus
    Public Const ME_BUS_TYPE_PCI As Integer = &H1A0001
    Public Const ME_BUS_TYPE_USB As Integer = &H1A0002
    Public Const ME_BUS_TYPE_LAN_PCI As Integer = &H1A0101
    Public Const ME_BUS_TYPE_LAN_USB As Integer = &H1A0102

    Public Const ME_PLUGGED_INVALID As Integer = &H0S
    Public Const ME_PLUGGED_ANY As Integer = &H1B0000     'ME_PLUGGED_ANY only for checking status
    Public Const ME_PLUGGED_IN As Integer = &H1B0001
    Public Const ME_PLUGGED_OUT As Integer = &H1B0002

    Public Const ME_EXTENSION_TYPE_INVALID As Integer = &H0S
    Public Const ME_EXTENSION_TYPE_NONE As Integer = &H1C0001
    Public Const ME_EXTENSION_TYPE_MUX32M As Integer = &H1C0002
    Public Const ME_EXTENSION_TYPE_DEMUX32 As Integer = &H1C0003
    Public Const ME_EXTENSION_TYPE_MUX32S As Integer = &H1C0004
    Public Const ME_EXTENSION_TYPE_ME1001 As Integer = &H1C0005


    Public Const ME_ACCESS_TYPE_INVALID As Integer = &H0S
    Public Const ME_ACCESS_TYPE_ANY As Integer = &H1D0000
    Public Const ME_ACCESS_TYPE_LOCAL As Integer = &H1D0001
    Public Const ME_ACCESS_TYPE_REMOTE As Integer = &H1D0002

    '===============================================================
    '  Defines for ConfigLoad
    '===============================================================

    Public Const ME_CONF_LOAD_CUSTOM_DRIVER As Integer = &H1000

    '==================================================================
    '  Defines for FPGA device
    '==================================================================

    Public Const ME_FPGA_FIRMWARE As UInt32 = &HFF000001UI
    Public Const ME_FPGA_SUBDEVICE As UInt32 = &HFF000002UI

    '==================================================================
    '  Defines for meUtilityPWM
    '==================================================================

    Public Const ME_PWM_START_NO_FLAGS As Integer = &H0
    Public Const ME_PWM_START_CONNECT_INTERNAL As Integer = &H1

    '==================================================================
    '  Defines of flags for error handling
    '==================================================================

    Public Const ME_ERRNO_CLEAR_FLAGS As Integer = &H1


    '-------------------------------------------------------------------------------
    '
    '                             me-iDS Types
    '
    '-------------------------------------------------------------------------------

    Structure meIOSingle_t
        Dim iDevice As Integer
        Dim iSubdevice As Integer
        Dim iChannel As Integer
        Dim iDir As Integer
        Dim iValue As Integer
        Dim iTimeOut As Integer
        Dim iFlags As Integer
        Dim iErrno As Integer
    End Structure

    Structure meIOStreamConfig_t
        Dim iChannel As Integer
        Dim iStreamConfig As Integer
        Dim iRef As Integer
        Dim iFlags As Integer
    End Structure

    <StructLayout(LayoutKind.Sequential)> Structure meIOStreamTrigger
        Dim iAcqStartTrigType As Integer
        Dim iAcqStartTrigEdge As Integer
        Dim iAcqStartTrigChan As Integer
        Dim iAcqStartTicksLow As Integer
        Dim iAcqStartTicksHigh As Integer
        <VBFixedArray(9), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValArray, SizeConst:=10)> Dim iAcqStartArgs() As Integer
        Dim iScanStartTrigType As Integer
        Dim iScanStartTicksLow As Integer
        Dim iScanStartTicksHigh As Integer
        <VBFixedArray(9), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValArray, SizeConst:=10)> Dim iScanStartArgs() As Integer
        Dim iConvStartTrigType As Integer
        Dim iConvStartTicksLow As Integer
        Dim iConvStartTicksHigh As Integer
        <VBFixedArray(9), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValArray, SizeConst:=10)> Dim iConvStartArgs() As Integer
        Dim iScanStopTrigType As Integer
        Dim iScanStopCount As Integer
        <VBFixedArray(9), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValArray, SizeConst:=10)> Dim iScanStopArgs() As Integer
        Dim iAcqStopTrigType As Integer
        Dim iAcqStopCount As Integer
        <VBFixedArray(9), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValArray, SizeConst:=10)> Dim iAcqStopArgs() As Integer
        Dim iFlags As Integer

        'UPGRADE_TODO: "Initialize" must be called to initialize instances of this structure. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="B4BFF9E0-8631-45CF-910E-62AB3970F27B"'
        Public Sub Initialize()
            ReDim iAcqStartArgs(9)
            ReDim iScanStartArgs(9)
            ReDim iConvStartArgs(9)
            ReDim iScanStopArgs(9)
            ReDim iAcqStopArgs(9)
        End Sub
    End Structure

    Structure meIOStreamStart_t
        Dim iDevice As Integer
        Dim iSubdevice As Integer
        Dim iStartMode As Integer
        Dim iTimeOut As Integer
        Dim iFlags As Integer
        Dim iErrno As Integer
    End Structure

    Structure meIOStreamStop_t
        Dim iDevice As Integer
        Dim iSubdevice As Integer
        Dim iStopMode As Integer
        Dim iFlags As Integer
        Dim iErrno As Integer
    End Structure



    '-------------------------------------------------------------------------------
    '
    ' ME-iDS Error Codes
    '
    '-------------------------------------------------------------------------------

    Public Const ME_ERRNO_SUCCESS As Integer = 0
    Public Const ME_ERRNO_INVALID_DEVICE As Integer = 1
    Public Const ME_ERRNO_INVALID_SUBDEVICE As Integer = 2
    Public Const ME_ERRNO_INVALID_CHANNEL As Integer = 3
    Public Const ME_ERRNO_INVALID_SINGLE_CONFIG As Integer = 4
    Public Const ME_ERRNO_INVALID_REF As Integer = 5
    Public Const ME_ERRNO_INVALID_TRIG_CHAN As Integer = 6
    Public Const ME_ERRNO_INVALID_TRIG_TYPE As Integer = 7
    Public Const ME_ERRNO_INVALID_TRIG_EDGE As Integer = 8
    Public Const ME_ERRNO_INVALID_TIMEOUT As Integer = 9
    Public Const ME_ERRNO_INVALID_FLAGS As Integer = 10
    Public Const ME_ERRNO_OPEN As Integer = 11
    Public Const ME_ERRNO_CLOSE As Integer = 12
    Public Const ME_ERRNO_NOT_OPEN As Integer = 13
    Public Const ME_ERRNO_INVALID_DIR As Integer = 14
    Public Const ME_ERRNO_PREVIOUS_CONFIG As Integer = 15
    Public Const ME_ERRNO_NOT_SUPPORTED As Integer = 16
    Public Const ME_ERRNO_SUBDEVICE_TYPE As Integer = 17
    Public Const ME_ERRNO_USER_BUFFER_SIZE As Integer = 18
    Public Const ME_ERRNO_LOCKED As Integer = 19
    Public Const ME_ERRNO_NO_MORE_SUBDEVICE_TYPE As Integer = 20
    Public Const ME_ERRNO_TIMEOUT As Integer = 21
    Public Const ME_ERRNO_SIGNAL As Integer = 22
    Public Const ME_ERRNO_INVALID_IRQ_SOURCE As Integer = 23
    Public Const ME_ERRNO_THREAD_RUNNING As Integer = 24
    Public Const ME_ERRNO_START_THREAD As Integer = 25
    Public Const ME_ERRNO_CANCEL_THREAD As Integer = 26
    Public Const ME_ERRNO_NO_CALLBACK As Integer = 27
    Public Const ME_ERRNO_USED As Integer = 28
    Public Const ME_ERRNO_INVALID_UNIT As Integer = 29
    Public Const ME_ERRNO_INVALID_MIN_MAX As Integer = 30
    Public Const ME_ERRNO_NO_RANGE As Integer = 31
    Public Const ME_ERRNO_INVALID_RANGE As Integer = 32
    Public Const ME_ERRNO_SUBDEVICE_BUSY As Integer = 33
    Public Const ME_ERRNO_INVALID_LOCK As Integer = 34
    Public Const ME_ERRNO_INVALID_SWITCH As Integer = 35
    Public Const ME_ERRNO_INVALID_ERROR_MSG_COUNT As Integer = 36
    Public Const ME_ERRNO_INVALID_STREAM_CONFIG As Integer = 37
    Public Const ME_ERRNO_INVALID_CONFIG_LIST_COUNT As Integer = 38
    Public Const ME_ERRNO_INVALID_ACQ_START_TRIG_TYPE As Integer = 39
    Public Const ME_ERRNO_INVALID_ACQ_START_TRIG_EDGE As Integer = 40
    Public Const ME_ERRNO_INVALID_ACQ_START_TRIG_CHAN As Integer = 41
    Public Const ME_ERRNO_INVALID_ACQ_START_TIMEOUT As Integer = 42
    Public Const ME_ERRNO_INVALID_ACQ_START_ARG As Integer = 43
    Public Const ME_ERRNO_INVALID_SCAN_START_TRIG_TYPE As Integer = 44
    Public Const ME_ERRNO_INVALID_SCAN_START_ARG As Integer = 45
    Public Const ME_ERRNO_INVALID_CONV_START_TRIG_TYPE As Integer = 46
    Public Const ME_ERRNO_INVALID_CONV_START_ARG As Integer = 47
    Public Const ME_ERRNO_INVALID_SCAN_STOP_TRIG_TYPE As Integer = 48
    Public Const ME_ERRNO_INVALID_SCAN_STOP_ARG As Integer = 49
    Public Const ME_ERRNO_INVALID_ACQ_STOP_TRIG_TYPE As Integer = 50
    Public Const ME_ERRNO_INVALID_ACQ_STOP_ARG As Integer = 51
    Public Const ME_ERRNO_SUBDEVICE_NOT_RUNNING As Integer = 52
    Public Const ME_ERRNO_INVALID_READ_MODE As Integer = 53
    Public Const ME_ERRNO_INVALID_VALUE_COUNT As Integer = 54
    Public Const ME_ERRNO_INVALID_WRITE_MODE As Integer = 55
    Public Const ME_ERRNO_INVALID_TIMER As Integer = 56
    Public Const ME_ERRNO_DEVICE_UNPLUGGED As Integer = 57
    Public Const ME_ERRNO_USED_INTERNAL As Integer = 58
    Public Const ME_ERRNO_INVALID_DUTY_CYCLE As Integer = 59
    Public Const ME_ERRNO_INVALID_WAIT As Integer = 60
    Public Const ME_ERRNO_CONNECT_REMOTE As Integer = 61
    Public Const ME_ERRNO_COMMUNICATION As Integer = 62
    Public Const ME_ERRNO_INVALID_SINGLE_LIST As Integer = 63
    Public Const ME_ERRNO_INVALID_MODULE_TYPE As Integer = 64
    Public Const ME_ERRNO_INVALID_START_MODE As Integer = 65
    Public Const ME_ERRNO_INVALID_STOP_MODE As Integer = 66
    Public Const ME_ERRNO_INVALID_FIFO_IRQ_THRESHOLD As Integer = 67
    Public Const ME_ERRNO_INVALID_POINTER As Integer = 68
    Public Const ME_ERRNO_CREATE_EVENT As Integer = 69
    Public Const ME_ERRNO_LACK_OF_RESOURCES As Integer = 70
    Public Const ME_ERRNO_CANCELLED As Integer = 71
    Public Const ME_ERRNO_RING_BUFFER_OVERFLOW As Integer = 72
    Public Const ME_ERRNO_SOFTWARE_BUFFER_OVERFLOW As Integer = ME_ERRNO_RING_BUFFER_OVERFLOW
    Public Const ME_ERRNO_RING_BUFFER_UNDERFLOW As Integer = 73
    Public Const ME_ERRNO_SOFTWARE_BUFFER_UNDERFLOW As Integer = ME_ERRNO_RING_BUFFER_UNDERFLOW
    Public Const ME_ERRNO_INVALID_IRQ_EDGE As Integer = 74
    Public Const ME_ERRNO_INVALID_IRQ_ARG As Integer = 75
    Public Const ME_ERRNO_INVALID_CAP As Integer = 76
    Public Const ME_ERRNO_INVALID_CAP_ARG_COUNT As Integer = 77
    Public Const ME_ERRNO_INTERNAL As Integer = 78
    Public Const ME_ERRNO_VALUE_OUT_OF_RANGE As Integer = 79
    Public Const ME_ERRNO_HARDWARE_FIFO_OVERFLOW As Integer = 80
    Public Const ME_ERRNO_HARDWARE_BUFFER_OVERFLOW As Integer = ME_ERRNO_HARDWARE_FIFO_OVERFLOW
    Public Const ME_ERRNO_HARDWARE_FIFO_UNDERFLOW As Integer = 81
    Public Const ME_ERRNO_HARDWARE_BUFFER_UNDERFLOW As Integer = ME_ERRNO_HARDWARE_FIFO_UNDERFLOW
    Public Const ME_ERRNO_CONFIG_LOAD_FAILED As Integer = 82
    Public Const ME_ERRNO_PROPERTY_CONTAINER As Integer = 83
    Public Const ME_ERRNO_PROPERTY_NOT_A_CONTAINER As Integer = 84
    Public Const ME_ERRNO_PROPERTY_DATA_TYPE As Integer = 85
    Public Const ME_ERRNO_PROPERTY_PATH As Integer = 86
    Public Const ME_ERRNO_PROPERTY_INDEX As Integer = 87
    Public Const ME_ERRNO_PROPERTY_BUFFER_TOO_SMALL As Integer = 88
    Public Const ME_ERRNO_PROPERTY_UNKNOWN As Integer = 89
    Public Const ME_ERRNO_PROPERTY_ATTRIBUTE_UNKNOWN As Integer = 90
    Public Const ME_ERRNO_PROPERTY_ATTRIBUTE_UNSUPPORTED As Integer = 91
    Public Const ME_ERRNO_PROPERTY_SELECTION_INVALID As Integer = 92
    Public Const ME_ERRNO_PROPERTY_VALUE_INVALID As Integer = 93
    Public Const ME_ERRNO_PROPERTY_READ_ONLY As Integer = 94

    '=======================================================================
    '  ME_ERRNO_INVALID_ERROR_NUMBER is always the error constant
    '  with the greatest number when new error codes are added
    '=======================================================================
    Public Const ME_ERRNO_INVALID_ERROR_NUMBER As Integer = 95



    '-------------------------------------------------------------------------------
    '
    '                             ME-iDS Functions
    '
    '-------------------------------------------------------------------------------

    '==================================================================
    '  Functions to access the driver system
    '==================================================================

    Declare Function meOpen Lib "meIDSmainVB.dll" Alias "_meOpen@4" (ByVal iFlags As Integer) As Integer

    Declare Function meClose Lib "meIDSmainVB.dll" Alias "_meClose@4" (ByVal iFlags As Integer) As Integer

    Declare Function meLockDriver Lib "meIDSmainVB.dll" Alias "_meLockDriver@8" (ByVal iLock As Integer, ByVal iFlags As Integer) As Integer
    Declare Function meLockDevice Lib "meIDSmainVB.dll" Alias "_meLockDevice@12" (ByVal iDevice As Integer, ByVal iLock As Integer, ByVal iFlags As Integer) As Integer
    Declare Function meLockSubdevice Lib "meIDSmainVB.dll" Alias "_meLockSubdevice@16" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iLock As Integer, ByVal iFlags As Integer) As Integer

    '==================================================================
    '  Error handling functions
    '==================================================================

    Declare Function meErrorGetLast Lib "meIDSmainVB.dll" Alias "_meErrorGetLast@8" (ByRef piErrorCode As Integer, ByVal iFlags As Integer) As Integer
    Declare Function meErrorGetLastMessage Lib "meIDSmainVB.dll" Alias "_meErrorGetLastMessage@8" (ByVal pcErrorMsg As String, ByVal iCount As Integer) As Integer
    Declare Function meErrorGetMessage Lib "meIDSmainVB.dll" Alias "_meErrorGetMessage@12" (ByVal iErrorCode As Integer, ByVal pcErrorMsg As String, ByVal iCount As Integer) As Integer
    Declare Function meErrorSetDefaultProc Lib "meIDSmainVB.dll" Alias "_meErrorSetDefaultProc@4" (ByVal iSwitch As Integer) As Integer
    ' Declare Function meErrorSetUserProc Lib "meIDSmainVB.dll" Alias "_meErrorSetUserProc@4" (meErrorCB_t pErrorProc) As Long

    '==================================================================
    ' Functions to perform I/O on a device
    '==================================================================

    ' Declare Function meIOIrqSetCallback Lib "meIDSmainVB.dll" Alias "_meIOIrqSetCallback@20" (ByVal iDevice As Long, ByVal iSubdevice As Long, meIOIrqCB_t pCallback, void *pCallbackContext, ByVal iFlags As Long) As Long

    Declare Function meIOIrqStart Lib "meIDSmainVB.dll" Alias "_meIOIrqStart@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iChannel As Integer, ByVal iIrqSource As Integer, ByVal iIrqEdge As Integer, ByVal iIrqArg As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOIrqStop Lib "meIDSmainVB.dll" Alias "_meIOIrqStop@16" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iChannel As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOIrqWait Lib "meIDSmainVB.dll" Alias "_meIOIrqWait@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iChannel As Integer, ByRef plIrqCount As Integer, ByRef plValue As Integer, ByVal iTimeOut As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOResetDevice Lib "meIDSmainVB.dll" Alias "_meIOResetDevice@8" (ByVal iDevice As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOResetSubdevice Lib "meIDSmainVB.dll" Alias "_meIOResetSubdevice@12" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOStreamFrequencyToTicks Lib "meIDSmainVB.dll" Alias "_meIOStreamFrequencyToTicks@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iTimer As Integer, ByRef pdFrequency As Double, ByRef plTicksLow As Integer, ByRef plTicksHigh As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOSingleConfig Lib "meIDSmainVB.dll" Alias "_meIOSingleConfig@36" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iChannel As Integer, ByVal iSingleConfig As Integer, ByVal iRef As Integer, ByVal iTrigChan As Integer, ByVal iTrigType As Integer, ByVal iTrigEdge As Integer, ByVal iFlags As Integer) As Integer

    'UPGRADE_WARNING: Structure meIOSingle may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function meIOSingle Lib "meIDSmainVB.dll" Alias "_meIOSingle@12" (ByRef pSingleList As meIOSingle_t, ByVal iCount As Integer, ByVal iFlag As Integer) As Integer

    Declare Function meIOSingleTimeToTicks Lib "meIDSmainVB.dll" Alias "_meIOSingleTimeToTicks@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iTimer As Integer, ByRef pdTime As Double, ByRef piTicksLow As Integer, ByRef piTicksHigh As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOSingleTicksToTime Lib "meIDSmainVB.dll" Alias "_meIOSingleTicksToTime@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iTimer As Integer, ByVal iTicksLow As Integer, ByVal iTicksHigh As Integer, ByRef pdTime As Double, ByVal iFlags As Integer) As Integer

    Declare Function meIOSetChannelOffset Lib "meIDSmainVB.dll" Alias "_meIOSetChannelOffset@24" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iChannel As Integer, ByVal iRange As Integer, ByRef pdOffset As Double, ByVal iFlags As Integer) As Integer

    'UPGRADE_WARNING: Structure meIOStreamTrigger may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    'UPGRADE_WARNING: Structure meIOStreamConfig may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function meIOStreamConfig Lib "meIDSmainVB.dll" Alias "_meIOStreamConfig@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByRef pConfigList As meIOStreamConfig_t, ByVal iCount As Integer, ByRef pTrigger As meIOStreamTrigger, ByVal iFifoIrqThreshold As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOStreamRead Lib "meIDSmainVB.dll" Alias "_meIOStreamRead@24" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iReadMode As Integer, ByRef plValues As Integer, ByRef plCount As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOStreamWrite Lib "meIDSmainVB.dll" Alias "_meIOStreamWrite@24" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iWriteMode As Integer, ByRef plValues As Integer, ByRef plCount As Integer, ByVal iFlags As Integer) As Integer

    'UPGRADE_WARNING: Structure meIOStreamStart may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function meIOStreamStart Lib "meIDSmainVB.dll" Alias "_meIOStreamStart@12" (ByRef pStartList As meIOStreamStart_t, ByVal iCount As Integer, ByVal iFlags As Integer) As Integer

    'UPGRADE_WARNING: Structure meIOStreamStop may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function meIOStreamStop Lib "meIDSmainVB.dll" Alias "_meIOStreamStop@12" (ByRef pStopList As meIOStreamStop_t, ByVal iCount As Integer, ByVal iFlags As Integer) As Integer

    Declare Function meIOStreamStatus Lib "meIDSmainVB.dll" Alias "_meIOStreamStatus@24" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iWait As Integer, ByRef plStatus As Integer, ByRef plCount As Integer, ByVal iFlags As Integer) As Integer

    ' Declare Function meIOStreamSetCallbacks Lib "meIDSmainVB.dll" Alias "_meIOStreamSetCallbacks@36" (ByVal iDevice As Long, ByVal iSubdevice As Long, meIOStreamCB_t pStartCB, void *pStartCBContext, meIOStreamCB_t pNewValuesCB, void *pNewValuesCBContext, meIOStreamCB_t pEndCB, void *pEndCBContext, ByVal iFlags) As Long

    Declare Function meIOStreamTimeToTicks Lib "meIDSmainVB.dll" Alias "_meIOStreamTimeToTicks@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iTimer As Integer, ByRef pdTime As Double, ByRef plTicksLow As Integer, ByRef plTicksHigh As Integer, ByVal iFlags As Integer) As Integer


    '==================================================================
    '  Functions to query the driver system
    '==================================================================

    Declare Function meQueryDescriptionDevice Lib "meIDSmainVB.dll" Alias "_meQueryDescriptionDevice@12" (ByVal iDevice As Integer, ByVal pcDescription As String, ByVal iCount As Integer) As Integer

    Declare Function meQueryInfoDevice Lib "meIDSmainVB.dll" Alias "_meQueryInfoDevice@36" (ByVal iDevice As Integer, ByRef plVendorId As Integer, ByRef plDeviceId As Integer, ByRef plSerialNo As Integer, ByRef plBusType As Integer, ByRef plBusNo As Integer, ByRef plDevNo As Integer, ByRef plFuncNo As Integer, ByRef plPlugged As Integer) As Integer

    Declare Function meQueryNameDevice Lib "meIDSmainVB.dll" Alias "_meQueryNameDevice@12" (ByVal iDevice As Integer, ByVal pcName As String, ByVal iCount As Integer) As Integer

    Declare Function meQueryNameDeviceDriver Lib "meIDSmainVB.dll" Alias "_meQueryNameDeviceDriver@12" (ByVal iDevice As Integer, ByVal pcName As String, ByVal iCount As Integer) As Integer

    Declare Function meQueryNumberDevices Lib "meIDSmainVB.dll" Alias "_meQueryNumberDevices@4" (ByRef plNumber As Integer) As Integer

    Declare Function meQueryNumberSubdevices Lib "meIDSmainVB.dll" Alias "_meQueryNumberSubdevices@8" (ByVal iDevice As Integer, ByRef plNumber As Integer) As Integer

    Declare Function meQueryNumberChannels Lib "meIDSmainVB.dll" Alias "_meQueryNumberChannels@12" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByRef plNumber As Integer) As Integer

    Declare Function meQueryNumberRanges Lib "meIDSmainVB.dll" Alias "_meQueryNumberRanges@16" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iUnit As Integer, ByRef plNumber As Integer) As Integer

    Declare Function meQueryRangeByMinMax Lib "meIDSmainVB.dll" Alias "_meQueryRangeByMinMax@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iUnit As Integer, ByRef pdMin As Double, ByRef pdMax As Double, ByRef plMaxData As Integer, ByRef plRange As Integer) As Integer

    Declare Function meQueryRangeInfo Lib "meIDSmainVB.dll" Alias "_meQueryRangeInfo@28" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iRange As Integer, ByRef plUnit As Integer, ByRef pdMin As Double, ByRef pdMax As Double, ByRef plMaxData As Integer) As Integer

    Declare Function meQuerySubdeviceByType Lib "meIDSmainVB.dll" Alias "_meQuerySubdeviceByType@20" (ByVal iDevice As Integer, ByVal iStartSubdevice As Integer, ByVal iType As Integer, ByVal iSubtype As Integer, ByRef plSubdevice As Integer) As Integer

    Declare Function meQuerySubdeviceType Lib "meIDSmainVB.dll" Alias "_meQuerySubdeviceType@16" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByRef plType As Integer, ByRef plSubtype As Integer) As Integer

    Declare Function meQuerySubdeviceCaps Lib "meIDSmainVB.dll" Alias "_meQuerySubdeviceCaps@12" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByRef plCaps As Integer) As Integer

    Declare Function meQuerySubdeviceCapsArgs Lib "meIDSmainVB.dll" Alias "_meQuerySubdeviceCapsArgs@20" (ByVal iDevice As Integer, ByVal iSubdevice As Integer, ByVal iCap As Integer, ByRef plArgs As Integer, ByVal iCount As Integer) As Integer

    Declare Function meQueryVersionLibrary Lib "meIDSmainVB.dll" Alias "_meQueryVersionLibrary@4" (ByRef plVersion As Integer) As Integer

    Declare Function meQueryVersionMainDriver Lib "meIDSmainVB.dll" Alias "_meQueryVersionMainDriver@4" (ByRef plVersion As Integer) As Integer

    Declare Function meQueryVersionDeviceDriver Lib "meIDSmainVB.dll" Alias "_meQueryVersionDeviceDriver@8" (ByVal iDevice As Integer, ByRef plVersion As Integer) As Integer

    '==================================================================
    '  Common utility functions
    '==================================================================

    'UPGRADE_WARNING: Structure meIOStreamConfig may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function meUtilityExtractValues Lib "meIDSmainVB.dll" Alias "_meUtilityExtractValues@28" (ByVal iChannel As Integer, ByRef plAIBuffer As Integer, ByVal iAIBufferCount As Integer, ByRef pConfigList As meIOStreamConfig_t, ByVal iConfigListCount As Integer, ByRef plChanBuffer As Integer, ByRef plChanBufferCount As Integer) As Integer

    Declare Function meUtilityDigitalToPhysical Lib "meIDSmainVB.dll" Alias "_meUtilityDigitalToPhysical@40" (ByVal dMin As Double, ByVal dMax As Double, ByVal iMaxData As Integer, ByVal iData As Integer, ByVal iModuleType As Integer, ByVal dRefValue As Double, ByRef pdPhysical As Double) As Integer

    Declare Function meUtilityDigitalToPhysicalV Lib "meIDSmainVB.dll" Alias "_meUtilityDigitalToPhysicalV@44" (ByVal dMin As Double, ByVal dMax As Double, ByVal iMaxData As Integer, ByRef plDataBuffer As Integer, ByVal iCount As Integer, ByVal iModuleType As Integer, ByVal dRefValue As Double, ByRef pdPhysicalBuffer As Double) As Integer

    Declare Function meUtilityPhysicalToDigital Lib "meIDSmainVB.dll" Alias "_meUtilityPhysicalToDigital@32" (ByVal dMin As Double, ByVal dMax As Double, ByVal iMaxData As Integer, ByVal dPhysical As Double, ByRef plData As Integer) As Integer

    Declare Function meUtilityPhysicalToDigitalV Lib "meIDSmainVB.dll" Alias "_meUtilityPhysicalToDigitalV@32" (ByVal dMin As Double, ByVal dMax As Double, ByVal iMaxData As Integer, ByRef pdPhysicalBuffer As Double, ByVal iCount As Integer, ByRef plDataBuffer As Integer) As Integer

    Declare Function meUtilityPWMStart Lib "meIDSmainVB.dll" Alias "_meUtilityPWMStart@32" (ByVal iDevice As Integer, ByVal iSubdevice1 As Integer, ByVal iSubdevice2 As Integer, ByVal iSubdevice3 As Integer, ByVal iRef As Integer, ByVal iPrescaler As Integer, ByVal iDutyCycle As Integer, ByVal iFlag As Integer) As Integer

    Declare Function meUtilityPWMStop Lib "meIDSmainVB.dll" Alias "_meUtilityPWMStop@8" (ByVal iDevice As Integer, ByVal iSubdevice1 As Integer) As Integer



End Module