﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using meIDS_CS;
using meIDSTools;

namespace TestConsole_meIOResetDevice_CS
{
    class TestConsole_meIOResetDevice
    {
        static void Main(string[] args)
        {
            int i_number_of_devices = TestConsoleGeneric.TestConsoleMEIDSProlog();

            if (i_number_of_devices <= 0)
            {
                return;
            }

            // ---------------------------------------------------------------------

            // Reset all devices in the system

            System.Console.Write(   "Press any key to reset all devices\n" +
                                    "(and therefore, automatically, all sub-devices).\n\n");

            System.Console.ReadKey(true);

            for (int index_device = 0; index_device < i_number_of_devices; index_device++)
            {
                meIDS.meIOResetDevice(index_device, meIDS.ME_IO_RESET_DEVICE_NO_FLAGS);
            }
         			
	        meIDS.meClose(0);
          
 	        System.Console.Write("All ME-iDS devices reset\n\n");

			System.Console.Write("Press any key to terminate\n\n");

            System.Console.ReadKey(true);
        }
   }
}

