#pragma once

#include "ME5xxxPP.h"

// CME5xxxPPDI dialog

class CME5xxxPPDI : public CME5xxxPP
{
	DECLARE_DYNAMIC(CME5xxxPPDI)

public:
	CME5xxxPPDI();
	virtual ~CME5xxxPPDI();

// Dialog Data
	enum { IDD = IDD_PP_DI };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedReset();
	afx_msg void OnSingleBnClickedCheckHardwareTrigger();
	afx_msg void OnSingleBnClickedRead();
	afx_msg void OnStreamingStartBnClickedCheckHardwareTrigger();
	afx_msg void OnStreamingBnClickedButtonStart();
	afx_msg void OnStreamingBnClickedButtonFileBrowse();
	afx_msg void OnStreamingBnClickedCheckInternalCounter();
	afx_msg void OnStreamingStopBnClickedCheckStopAfter();
	afx_msg void OnStreamingBnClickedButtonStop();
	afx_msg void OnStreamingStopBnClickedCheckHardwareTrigger();

private:
	
	static int __stdcall StreamingStartCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode);
	
	static int __stdcall StreamingNewValuesCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode);
	
	static int __stdcall StreamingEndCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode);

	FILE* m_pDataFile;

	int* m_piDataBuffer;

	int m_iDataBufferSize;

	int m_iDataFileSize;

	int m_iAcquisitionSize;

public:
};
