Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        Dim i_error As Integer
		
        Dim i_version As Integer
		
        Dim i_number_devices As Integer
		
        Dim i_index_device As Integer
		
        Dim i_number_subdevices As Integer
		
        Dim i_index_subdevice As Integer

        Dim s_string As New VB6.FixedLengthString(1024)
		
        Dim i_subdevice_type As Integer
		
        Dim i_number_of_channels As Integer
		
        Dim i_subdevice_subtype As Integer
		
        i_error = meOpen(0)
		
        i_error = meQueryVersionLibrary(i_version)
		
        LibraryVersion.Text = Hex(i_version)
		
        i_error = meQueryVersionMainDriver(i_version)
		
        MainDriverVersion.Text = Hex(i_version)
		
        i_error = meQueryNumberDevices(i_number_devices)
		
        NumberOfDevices.Text = Str(i_number_devices) & " Devices:"
		
        If i_number_devices = 0 Then

            SystemInfo.Text = "No devices found"

            Exit Sub

        Else

            SystemInfo.Text = ""

        End If
		
        For i_index_device = 0 To i_number_devices - 1

            i_error = meQueryNameDevice(i_index_device, s_string.Value, 1024)

            SystemInfo.Text = SystemInfo.Text & Str(i_index_device + 1) & ". "

            SystemInfo.Text = SystemInfo.Text & s_string.Value

            SystemInfo.Text = SystemInfo.Text & vbNewLine

            i_error = meQueryDescriptionDevice(i_index_device, s_string.Value, 1024)

            SystemInfo.Text = SystemInfo.Text & "Description "

            SystemInfo.Text = SystemInfo.Text & s_string.Value

            SystemInfo.Text = SystemInfo.Text & vbNewLine

            i_error = meQueryNameDeviceDriver(i_index_device, s_string.Value, 1024)

            SystemInfo.Text = SystemInfo.Text & "Driver: "

            SystemInfo.Text = SystemInfo.Text & s_string.Value

            SystemInfo.Text = SystemInfo.Text & " - Version: "

            i_error = meQueryVersionDeviceDriver(i_index_device, i_version)

            SystemInfo.Text = SystemInfo.Text & Hex(i_version)

            SystemInfo.Text = SystemInfo.Text & vbNewLine

            i_error = meQueryNumberSubdevices(i_index_device, i_number_subdevices)

            SystemInfo.Text = SystemInfo.Text & Str(i_number_subdevices)

            SystemInfo.Text = SystemInfo.Text & " Subdevices"

            SystemInfo.Text = SystemInfo.Text & vbNewLine

            For i_index_subdevice = 0 To i_number_subdevices - 1

                SystemInfo.Text = SystemInfo.Text & "        "

                SystemInfo.Text = SystemInfo.Text & Str(i_index_subdevice)

                SystemInfo.Text = SystemInfo.Text & ". Type: "

                i_error = meQuerySubdeviceType(i_index_device, i_index_subdevice, i_subdevice_type, i_subdevice_subtype)

                SystemInfo.Text = SystemInfo.Text & Hex(i_subdevice_type)

                SystemInfo.Text = SystemInfo.Text & "    Subtype: "

                SystemInfo.Text = SystemInfo.Text & Hex(i_subdevice_subtype)

                SystemInfo.Text = SystemInfo.Text & "    Channels: "

                i_error = meQueryNumberChannels(i_index_device, i_index_subdevice, i_number_of_channels)

                SystemInfo.Text = SystemInfo.Text & Str(i_number_of_channels)

                SystemInfo.Text = SystemInfo.Text & vbNewLine

            Next i_index_subdevice

            SystemInfo.Text = SystemInfo.Text & vbNewLine

        Next i_index_device
		
        i_error = meClose(0)
		
	End Sub

    Private Sub SystemInfo_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SystemInfo.TextChanged

    End Sub
End Class