// Con_meResetDevice.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include <stdio.h>
#include <conio.h>

#include <memory.h>

extern "C"
{
#include "..\\medriver.h"
}

#include "..\\TestConsoleGeneric.h"

#ifdef WIN64

#pragma comment (lib, "..\\meIDSmain64.lib")

#else

#pragma comment (lib, "..\\meIDSmain.lib")

#endif

int _tmain(int argc, _TCHAR* argv[])
{
	// Call generic console function in parent directory to 
	// open system and list the available devices and subdevices.

	int i_number_of_devices = TestConsoleMEIDSProlog();

	if(i_number_of_devices <= 0)
	{
		return(-1);
	}

	// ---------------------------------------------------------------------
	
	printf(	"Press any key to reset all devices\n"
            "(and therefore, automatically, all sub-devices).\n\n");

	getch();

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		meIOResetDevice(index_device, ME_IO_RESET_DEVICE_NO_FLAGS);
	}
			
	meClose(0);
			
	printf(	"All ME-iDS devices reset\n\n"
			"Press any key to terminate\n\n");

	getch();
	
	return 0;
}

